Index: trunk/src/VBox/Runtime/testcase/tstRTUri.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstRTUri.cpp	(revision 58064)
+++ trunk/src/VBox/Runtime/testcase/tstRTUri.cpp	(revision 58065)
@@ -314,6 +314,6 @@
         /* .pszUri           =*/ "file:///C:%5Cover%5C%20%3C%3E%23%25%22%7B%7D%7C%5E%5B%5D%60%5Cthere",
         /* .uFormat          =*/ URI_FILE_FORMAT_WIN,
-        /* .pszCreatedPath   =*/ NULL,    /* Same as pszPath. */
-        /* .pszCreatedUri    =*/ NULL,    /* Same as pszUri. */
+        /* .pszCreatedPath   =*/ "C:\\over\\ <>#%\"{}|^[]`\\there",
+        /* .pszCreatedUri    =*/ "file:///C:%5Cover%5C%20%3C%3E%23%25%22%7B%7D%7C%5E%5B%5D%60%5Cthere",
         /* PathCreateFromUrl =   "C:\\over\\ <>#%\"{}|^[]`\\there" - same */
         /* UrlCreateFromPath =   "file:///C:/over/%20%3C%3E%23%25%22%7B%7D%7C%5E%5B%5D%60/there" - differs */
@@ -323,6 +323,6 @@
         /* .pszUri           =*/ "file:///over/%20%3C%3E%23%25%22%7B%7D%7C%5E%5B%5D%60/there",
         /* .uFormat          =*/ URI_FILE_FORMAT_UNIX,
-        /* .pszCreatedPath   =*/ NULL,    /* Same as pszPath. */
-        /* .pszCreatedUri    =*/ NULL,    /* Same as pszUri. */
+        /* .pszCreatedPath   =*/ "/over/ <>#%\"{}|^[]`/there",
+        /* .pszCreatedUri    =*/ "file:///over/%20%3C%3E%23%25%22%7B%7D%7C%5E%5B%5D%60/there",
         /* PathCreateFromUrl =   "\\over\\ <>#%\"{}|^[]`\\there" - differs */
         /* UrlCreateFromPath =   "file:///over/%20%3C%3E%23%25%22%7B%7D%7C%5E%5B%5D%60/there" - same */
@@ -332,6 +332,6 @@
         /* .pszUri           =*/ "file://",
         /* .uFormat          =*/ URI_FILE_FORMAT_UNIX,
-        /* .pszCreatedPath   =*/ NULL,    /* Same as pszPath. */
-        /* .pszCreatedUri    =*/ NULL,    /* Same as pszUri. */
+        /* .pszCreatedPath   =*/ NULL,
+        /* .pszCreatedUri    =*/ "file://",
         /* PathCreateFromUrl =   "" - differs */
         /* UrlCreateFromPath => 0x80070057 (E_INVALIDARG) */
@@ -341,6 +341,6 @@
         /* .pszUri           =*/ "file://",
         /* .uFormat          =*/ URI_FILE_FORMAT_WIN,
-        /* .pszCreatedPath   =*/ NULL,    /* Same as pszPath. */
-        /* .pszCreatedUri    =*/ NULL,    /* Same as pszUri. */
+        /* .pszCreatedPath   =*/ NULL,
+        /* .pszCreatedUri    =*/ "file://",
         /* PathCreateFromUrl =   "" - differs */
         /* UrlCreateFromPath => 0x80070057 (E_INVALIDARG) */
@@ -350,6 +350,6 @@
         /* .pszUri           =*/ "file:///",
         /* .uFormat          =*/ URI_FILE_FORMAT_UNIX,
-        /* .pszCreatedPath   =*/ NULL,    /* Same as pszPath. */
-        /* .pszCreatedUri    =*/ NULL,    /* Same as pszUri. */
+        /* .pszCreatedPath   =*/ "/",
+        /* .pszCreatedUri    =*/ "file:///",
         /* PathCreateFromUrl =   "" - differs */
         /* UrlCreateFromPath =   "file:///" - same */
@@ -359,6 +359,6 @@
         /* .pszUri           =*/ "file:///",
         /* .uFormat          =*/ URI_FILE_FORMAT_WIN,
-        /* .pszCreatedPath   =*/ NULL,    /* Same as pszPath. */
-        /* .pszCreatedUri    =*/ NULL,    /* Same as pszUri. */
+        /* .pszCreatedPath   =*/ "\\",
+        /* .pszCreatedUri    =*/ "file:///",
         /* PathCreateFromUrl =   "" - differs */
         /* UrlCreateFromPath =   "file:///" - same */
@@ -368,6 +368,6 @@
         /* .pszUri           =*/ "file:///foo/bar",
         /* .uFormat          =*/ URI_FILE_FORMAT_UNIX,
-        /* .pszCreatedPath   =*/ NULL,    /* Same as pszPath. */
-        /* .pszCreatedUri    =*/ NULL,    /* Same as pszUri. */
+        /* .pszCreatedPath   =*/ "/foo/bar",
+        /* .pszCreatedUri    =*/ "file:///foo/bar",
         /* PathCreateFromUrl =   "\\foo\\bar" - differs */
         /* UrlCreateFromPath =   "file:///foo/bar" - same */
@@ -377,6 +377,6 @@
         /* .pszUri           =*/ "file:///foo%5Cbar",
         /* .uFormat          =*/ URI_FILE_FORMAT_WIN,
-        /* .pszCreatedPath   =*/ NULL,    /* Same as pszPath. */
-        /* .pszCreatedUri    =*/ NULL,    /* Same as pszUri. */
+        /* .pszCreatedPath   =*/ "\\foo\\bar",
+        /* .pszCreatedUri    =*/ "file:///foo%5Cbar",
         /* PathCreateFromUrl =   "\\foo\\bar" - same */
         /* UrlCreateFromPath =   "file:///foo/bar" - differs */
@@ -386,6 +386,6 @@
         /* .pszUri           =*/ "file:///C:/over/%20%3C%3E%23%25%22%7B%7D%7C%5E%5B%5D%60/there",
         /* .uFormat          =*/ URI_FILE_FORMAT_UNIX,
-        /* .pszCreatedPath   =*/ NULL,    /* Same as pszPath. */
-        /* .pszCreatedUri    =*/ NULL,    /* Same as pszUri. */
+        /* .pszCreatedPath   =*/ "C:/over/ <>#%\"{}|^[]`/there",
+        /* .pszCreatedUri    =*/ "file:///C:/over/%20%3C%3E%23%25%22%7B%7D%7C%5E%5B%5D%60/there",
         /* PathCreateFromUrl =   "C:\\over\\ <>#%\"{}|^[]`\\there" - differs */
         /* UrlCreateFromPath =   "file:///C:/over/%20%3C%3E%23%25%22%7B%7D%7C%5E%5B%5D%60/there" - same */
@@ -395,6 +395,6 @@
         /* .pszUri           =*/ "file:///over%5C%20%3C%3E%23%25%22%7B%7D%7C%5E%5B%5D%60%5Cthere",
         /* .uFormat          =*/ URI_FILE_FORMAT_WIN,
-        /* .pszCreatedPath   =*/ NULL,    /* Same as pszPath. */
-        /* .pszCreatedUri    =*/ NULL,    /* Same as pszUri. */
+        /* .pszCreatedPath   =*/ "\\over\\ <>#%\"{}|^[]`\\there",
+        /* .pszCreatedUri    =*/ "file:///over%5C%20%3C%3E%23%25%22%7B%7D%7C%5E%5B%5D%60%5Cthere",
         /* PathCreateFromUrl =   "\\over\\ <>#%\"{}|^[]`\\there" - same */
         /* UrlCreateFromPath =   "file:///over/%20%3C%3E%23%25%22%7B%7D%7C%5E%5B%5D%60/there" - differs */
@@ -404,6 +404,6 @@
         /* .pszUri           =*/ "file:///usr/bin/grep",
         /* .uFormat          =*/ URI_FILE_FORMAT_UNIX,
-        /* .pszCreatedPath   =*/ NULL,    /* Same as pszPath. */
-        /* .pszCreatedUri    =*/ NULL,    /* Same as pszUri. */
+        /* .pszCreatedPath   =*/ "/usr/bin/grep",
+        /* .pszCreatedUri    =*/ "file:///usr/bin/grep",
         /* PathCreateFromUrl =   "\\usr\\bin\\grep" - differs */
         /* UrlCreateFromPath =   "file:///usr/bin/grep" - same */
@@ -413,6 +413,6 @@
         /* .pszUri           =*/ "file:///usr%5Cbin%5Cgrep",
         /* .uFormat          =*/ URI_FILE_FORMAT_WIN,
-        /* .pszCreatedPath   =*/ NULL,    /* Same as pszPath. */
-        /* .pszCreatedUri    =*/ NULL,    /* Same as pszUri. */
+        /* .pszCreatedPath   =*/ "\\usr\\bin\\grep",
+        /* .pszCreatedUri    =*/ "file:///usr%5Cbin%5Cgrep",
         /* PathCreateFromUrl =   "\\usr\\bin\\grep" - same */
         /* UrlCreateFromPath =   "file:///usr/bin/grep" - differs */
@@ -422,6 +422,6 @@
         /* .pszUri           =*/ "file:///somerootsubdir/isos/files.lst",
         /* .uFormat          =*/ URI_FILE_FORMAT_UNIX,
-        /* .pszCreatedPath   =*/ NULL,    /* Same as pszPath. */
-        /* .pszCreatedUri    =*/ NULL,    /* Same as pszUri. */
+        /* .pszCreatedPath   =*/ "/somerootsubdir/isos/files.lst",
+        /* .pszCreatedUri    =*/ "file:///somerootsubdir/isos/files.lst",
         /* PathCreateFromUrl =   "\\somerootsubdir\\isos\\files.lst" - differs */
         /* UrlCreateFromPath =   "file:///somerootsubdir/isos/files.lst" - same */
@@ -431,6 +431,6 @@
         /* .pszUri           =*/ "file:///not-a-cifsserver%5Cisos%5Cfiles.lst",
         /* .uFormat          =*/ URI_FILE_FORMAT_WIN,
-        /* .pszCreatedPath   =*/ NULL,    /* Same as pszPath. */
-        /* .pszCreatedUri    =*/ NULL,    /* Same as pszUri. */
+        /* .pszCreatedPath   =*/ "\\not-a-cifsserver\\isos\\files.lst",
+        /* .pszCreatedUri    =*/ "file:///not-a-cifsserver%5Cisos%5Cfiles.lst",
         /* PathCreateFromUrl =   "\\not-a-cifsserver\\isos\\files.lst" - same */
         /* UrlCreateFromPath =   "file:///not-a-cifsserver/isos/files.lst" - differs */
@@ -440,6 +440,6 @@
         /* .pszUri           =*/ "file:///rootsubdir/isos/files.lst",
         /* .uFormat          =*/ URI_FILE_FORMAT_UNIX,
-        /* .pszCreatedPath   =*/ NULL,    /* Same as pszPath. */
-        /* .pszCreatedUri    =*/ NULL,    /* Same as pszUri. */
+        /* .pszCreatedPath   =*/ "/rootsubdir/isos/files.lst",
+        /* .pszCreatedUri    =*/ "file:///rootsubdir/isos/files.lst",
         /* PathCreateFromUrl =   "\\rootsubdir\\isos\\files.lst" - differs */
         /* UrlCreateFromPath =   "file:///rootsubdir/isos/files.lst" - same */
@@ -449,6 +449,6 @@
         /* .pszUri           =*/ "file:///not-a-cifsserver-either%5Cisos%5Cfiles.lst",
         /* .uFormat          =*/ URI_FILE_FORMAT_WIN,
-        /* .pszCreatedPath   =*/ NULL,    /* Same as pszPath. */
-        /* .pszCreatedUri    =*/ NULL,    /* Same as pszUri. */
+        /* .pszCreatedPath   =*/ "\\not-a-cifsserver-either\\isos\\files.lst",
+        /* .pszCreatedUri    =*/ "file:///not-a-cifsserver-either%5Cisos%5Cfiles.lst",
         /* PathCreateFromUrl =   "\\not-a-cifsserver-either\\isos\\files.lst" - same */
         /* UrlCreateFromPath =   "file:///not-a-cifsserver-either/isos/files.lst" - differs */
@@ -537,19 +537,9 @@
                  : g_aCreateFileURIs[i].uFormat == URI_FILE_FORMAT_AUTO ? "URI_FILE_FORMAT_AUTO" : "URI_FILE_FORMAT_INVALID");
         RTPrintf("        /* .pszCreatedPath   =*/ ");
-        if (g_aCreateFileURIs[i].pszCreatedPath == NULL)
-            RTPrintf("NULL,    /* Same as pszPath. */\n");
-        else
-        {
-            tstPrintCString(g_aCreateFileURIs[i].pszCreatedPath);
-            RTPrintf(",\n");
-        }
+        tstPrintCString(g_aCreateFileURIs[i].pszCreatedPath);
+        RTPrintf(",\n");
         RTPrintf("        /* .pszCreatedUri    =*/ ");
-        if (g_aCreateFileURIs[i].pszCreatedUri == NULL)
-            RTPrintf("NULL,    /* Same as pszUri. */\n");
-        else
-        {
-            tstPrintCString(g_aCreateFileURIs[i].pszCreatedUri);
-            RTPrintf(",\n");
-        }
+        tstPrintCString(g_aCreateFileURIs[i].pszCreatedUri);
+        RTPrintf(",\n");
 
         /*
@@ -572,6 +562,5 @@
             tstPrintCString(pszResult);
             if (   g_aCreateFileURIs[i].pszPath
-                && strcmp(pszResult, g_aCreateFileURIs[i].pszCreatedPath
-                                     ? g_aCreateFileURIs[i].pszCreatedPath : g_aCreateFileURIs[i].pszPath) == 0)
+                && strcmp(pszResult, g_aCreateFileURIs[i].pszCreatedPath) == 0)
                 RTPrintf(" - same */\n");
             else
@@ -605,6 +594,5 @@
                 tstPrintCString(pszResult);
                 if (   g_aCreateFileURIs[i].pszUri
-                    && strcmp(pszResult, g_aCreateFileURIs[i].pszCreatedUri
-                                         ? g_aCreateFileURIs[i].pszCreatedUri : g_aCreateFileURIs[i].pszUri) == 0)
+                    && strcmp(pszResult, g_aCreateFileURIs[i].pszCreatedUri) == 0)
                     RTPrintf(" - same */\n");
                 else
@@ -679,15 +667,20 @@
 #endif
 
+    bool fSavedMayPanic = RTAssertSetMayPanic(false);
+    bool fSavedQuiet    = RTAssertSetQuiet(true);
+
     /* File Uri path */
     RTTestISub("RTUriFilePath");
     for (size_t i = 0; i < RT_ELEMENTS(g_aCreateFileURIs); ++i)
         CHECK_STR_API(RTUriFilePath(g_aCreateFileURIs[i].pszUri, g_aCreateFileURIs[i].uFormat),
-                      g_aCreateFileURIs[i].pszCreatedPath ? g_aCreateFileURIs[i].pszCreatedPath : g_aCreateFileURIs[i].pszPath);
+                      g_aCreateFileURIs[i].pszCreatedPath);
 
     /* File Uri creation */
     RTTestISub("RTUriFileCreate");
     for (size_t i = 0; i < RT_ELEMENTS(g_aCreateFileURIs); ++i)
-        CHECK_STR_API(RTUriFileCreate(g_aCreateFileURIs[i].pszPath),
-                      g_aCreateFileURIs[i].pszCreatedUri ? g_aCreateFileURIs[i].pszCreatedUri : g_aCreateFileURIs[i].pszUri);
+        CHECK_STR_API(RTUriFileCreate(g_aCreateFileURIs[i].pszPath), g_aCreateFileURIs[i].pszCreatedUri);
+
+    RTAssertSetMayPanic(fSavedMayPanic);
+    RTAssertSetQuiet(fSavedQuiet);
 
     return RTTestSummaryAndDestroy(hTest);